-------------------------------
--  SQL.sql for training course
--  Updated : 14 July 2023
-------------------------------
--  Table data
--
SELECT * 
FROM SEED.ABANK

--
SELECT [UPDTICK_0]
      ,[REFERENCE_0]
      ,[CUSTNO_0]
      ,[CUSTNAME_0]
      ,[DATELASTCONT_0]
      ,[BYWHOM_0]
      ,[FREETEXT_0]
      ,[FREETEXT_1]
      ,[FREETEXT_2]
      ,[FREETEXT_3]
      ,[FREETEXT_4]
      ,[FREETEXT_5]
      ,[FREETEXT_6]
      ,[FREETEXT_7]
      ,[FREETEXT_8]
      ,[FREETEXT_9]
      ,[CREDATTIM_0]
      ,[UPDDATTIM_0]
      ,[AUUID_0]
      ,[CREUSR_0]
      ,[UPDUSR_0]
      ,[ROWID]
FROM [SEED].[ZMSQL]
order by REFERENCE_0

-----------------------------
-- VIEW data
--
SELECT [CUSTERNAME_0]
      ,[OURREF_0]
      ,[LASTCONTACT_0]
      ,[BYWHOM_0]
FROM [SEED].[ZMVW1]

-----------------------------
-- WHERE
--
SELECT [REFERENCE_0]
      ,[CREDATTIM_0]
      ,[UPDDATTIM_0]
      ,[CUSTNO_0]
      ,[CUSTNAME_0]
      ,[DATELASTCONT_0]
      ,[BYWHOM_0]
      ,[FREETEXT_0]
      ,[FREETEXT_1]
      ,[FREETEXT_2]
      ,[FREETEXT_3]
FROM [SEED].[ZMSQL]
--WHERE BYWHOM_0 like ('Fred2%') 
--WHERE CUSTNO_0 in ('GB2','GB21')
--WHERE SUBSTRING(CUSTNO_0,1,3) = 'GB3'
-- WHERE BYWHOM_0 like ('Fred2%') and SUBSTRING(CUSTNO_0,1,3) in ('GB3','GB2')
ORDER BY CUSTNAME_0
--ORDER BY 3 desc

-----------------------------
--GROUPING
--
SELECT substring(CUSTNO_0,1,3), count(*) as 'How_many'
FROM [SEED].[ZMSQL]
group by substring(CUSTNO_0,1,3)
-- having count(*) >= 20

-----------------------------
-- Create temporary table
--
SELECT *
INTO SEED.ZMTEMP
FROM SEED.ZMSQL
WHERE SUBSTRING(CUSTNO_0,1,3) = 'GB3'
-- drop table SEED.ZMTEMP

-----------------------------
-- Table joins
--
SELECT 'X_'+X.CUSTNO_0 as 'COL HEADER ZMTEMP', 'Y_'+Y.CUSTNO_0 as 'COL HEADER ZMSQL'
FROM SEED.ZMTEMP X
	INNER JOIN  SEED.ZMSQL Y ON X.CUSTNO_0 = Y.CUSTNO_0
--	FULL OUTER JOIN  SEED.ZMSQL Y ON X.CUSTNO_0 = Y.CUSTNO_0

-----------------------------
-- INSERT
--
INSERT INTO SEED.ZMSQL 
([REFERENCE_0], [CUSTNO_0], [CUSTNAME_0], [DATELASTCONT_0], [BYWHOM_0], [FREETEXT_0], [FREETEXT_1], [FREETEXT_2], [FREETEXT_3], [FREETEXT_4], [FREETEXT_5], [FREETEXT_6], [FREETEXT_7], [FREETEXT_8], [FREETEXT_9], [CREDATTIM_0], [UPDDATTIM_0], [AUUID_0], [CREUSR_0], [UPDUSR_0])
VALUES (1001,'NEWCUST','New customer name',CURRENT_TIMESTAMP,'George','','','','','','','','','','',CURRENT_TIMESTAMP,CURRENT_TIMESTAMP,0,'ADMIN','ADMIN')

-----------------------------
-- UPDATE
--
UPDATE [SEED].[ZMSQL]
SET [CUSTNAME_0] = 'Updated record'
WHERE [REFERENCE_0] = 1001

-----------------------------
-- DELETE 
--
DELETE FROM [SEED].[ZMSQL]
WHERE [REFERENCE_0] >1000

-----------------------------
-- INDEXES
--
SELECT [REFERENCE_0]
      ,[CUSTNO_0]
      ,[CUSTNAME_0]
      ,[DATELASTCONT_0]
      ,[BYWHOM_0]
      ,[FREETEXT_0]
      ,[FREETEXT_1]
      ,[FREETEXT_2]
      ,[FREETEXT_3]
      ,[CREDATTIM_0]
      ,[UPDDATTIM_0]
FROM [SEED].[ZMSQL]
-- WHERE REFERENCE_0 = 171
-- WHERE REFERENCE_0 > 171
-- WHERE CUSTNAME_0 like '% name15'
-- WHERE UPPER(CUSTNAME_0) like UPPER('cust name15')  -- Using a function causes no index to be used
-- WHERE CUSTNAME_0 like UPPER('cust name15')  -- although only on the left side
-- WHERE BYWHOM_0 = 'Fred1'  -- There is no index on the BYWHOM_0 column to be used


-----------------------------
--  End of SQL.sql
-------------------------------