REM #################################################
REM ######          START OF SCRIPT            ######
REM #################################################
REM ##   Filename: mzCreateZMSQLmport.cmd
REM ##   Updated : 09 June 2023
REM ##   Author  : Mike Shaw (Sage UK, X3 Support)
REM #################################################
REM ##  Creates a TXT file that can be imported using
REM ##  ZMSQL import template
REM ##
REM ##   This script is provided "as-is" and is 
REM ##   intended for educational purposes only.
REM ##   No warranty is expressed or implied.
REM ##   Use at your own risk!
REM #################################################
@echo off
cls
setlocal EnableDelayedExpansion
REM  Site specific variables
set "mzX3root=D:\Sage\X3ERPV12\"
set "mzX3folder=SEED"
REM  end of site specific variables
set "runDate=%DATE:~0,2%%DATE:~3,2%%DATE:~8,2%"
set "mzFILE=mzZMSQLImport.txt"
set "mzX3importDirectory=."
set "mzFILENAME=%mzX3importDirectory%\%mzFILE%"
REM     mzRecords end number 
set "mzRecords=310"
REM     mzStart what sequence number to start at
set "mzStart=1"     
REM   Variable data - but may not want to change too much
set "mzDate=%runDate%"
REM  End of variables to change
REM   ----------------------------------   START OF THE REAL WORK   ---------------------------------
REM   Start of number of invoices loop
echo About to create file %mzFILENAME%
if not exist %mzX3importDirectory% (
	echo Cannot find %mzX3importDirectory%
	goto ZERROR
)
if exist %mzFILENAME% (
	echo Removing existing file %mzFILENAME%
	del %mzFILENAME% /q
)
echo.
For /f "tokens=1-2 delims=/:" %%a in ('time /t') do (set mzTimeNow=%%a%%b)
echo Run started at %mzTimeNow%
echo.
FOR /L %%r in (%mzStart%,1,%mzRecords%) DO (
	echo looping %%r of %mzRecords%
	set "mzCustNo=GB"
	set "mzCustName=Cust name"
	set "mzByWhom=Fred"
	set "FreeText1=First Text "
	set "FreeText2=Second Text "
	set "FreeText3=Third Text "
	REM   ---------  Start loop  -----------
	echo "X",%%r,"!mzCustNo!%%r","!mzCustName!%%r",%mzDate%,"!mzByWhom!%%r","!FreeText1!%%r","!FreeText2!%%r","!FreeText3!%%r">> %mzFILENAME%
	REM   ---------  End loop  -----------
) 
REM   ----------------------------------   END OF THE REAL WORK   ---------------------------------
goto END
:: FUNCTIONS
:randqty
SET /A RAND_NUM=%RANDOM% * (%2 - %1 + 1) / 32768 + %1
set "mzQty=!RAND_NUM!"
echo | set /p dummyname="%mzQty%%mzSEP%" >> %mzFILENAME%
goto :EOF
:randprice
SET /A RAND_NUM=%RANDOM% * (%2 - %1 + 1) / 32768 + %1
set "mzPrice=!RAND_NUM!"
echo | set /p dummyname="%mzPrice%%mzSEP%" >> %mzFILENAME%
goto :EOF
:ZERROR
echo.
echo  ERROR OCCURRED
echo.
For /f "tokens=1-2 delims=/:" %%a in ('time /t') do (set mzTimeNow=%%a%%b)
echo Run finished at %mzTimeNow%
echo.
rem pause
exit 1
:END
echo.
For /f "tokens=1-2 delims=/:" %%a in ('time /t') do (set mzTimeNow=%%a%%b)
echo Run finished at %mzTimeNow%
echo.
rem pause
REM #################################################
REM ######          END OF SCRIPT            ######
REM #################################################